---
title: Warning
slug: Web/HTTP/Headers/Warning
tags:
  - General Header
  - HTTP
  - Reference
  - header
---
<div>{{HTTPSidebar}}</div>

<div class="notecard note">
<p><strong>Note</strong>: The <code>Warning</code> header is soon to be deprecated; see <a href="https://github.com/httpwg/http-core/issues/139">Warning (https://github.com/httpwg/http-core/issues/139)</a> and <a href="https://github.com/whatwg/fetch/issues/913">Warning: header &amp; stale-while-revalidate (https://github.com/whatwg/fetch/issues/913)</a> for more details.</p>
</div>

<p>The <strong><code>Warning</code></strong> general HTTP header contains information about possible problems with the status of the message. More than one <code>Warning</code> header may appear in a response.</p>

<p><code>Warning</code> header fields can in general be applied to any message, however some warn-codes are specific to caches and can only be applied to response messages.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Header type</th>
   <td>{{Glossary("General header")}}</td>
  </tr>
  <tr>
   <th scope="row">{{Glossary("Forbidden header name")}}</th>
   <td>no</td>
  </tr>
 </tbody>
</table>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Warning: &lt;warn-code&gt; &lt;warn-agent&gt; &lt;warn-text&gt; [&lt;warn-date&gt;]
</pre>

<h2 id="Directives">Directives</h2>

<dl>
 <dt>&lt;warn-code&gt;</dt>
 <dd>A three-digit warning number. The first digit indicates whether the <code>Warning</code> is required to be deleted from a stored response after validation.
 <ul>
  <li><code>1xx</code> warn-codes describe the freshness or validation status of the response and will be deleted by a cache after deletion.</li>
  <li>
   <p><code>2xx</code> warn-codes describe some aspect of the representation that is not rectified by a validation and won't be deleted by a cache after validation unless a full response is sent.</p>
  </li>
 </ul>
 </dd>
 <dt>&lt;warn-agent&gt;</dt>
 <dd>
 <p>The name or pseudonym of the server or software adding the <code>Warning</code> header (might be "-" when the agent is unknown).</p>
 </dd>
 <dt>&lt;warn-text&gt;</dt>
 <dd>Advisory text describing the error.</dd>
 <dt>&lt;warn-date&gt;</dt>
 <dd>Optional. If more than one <code>Warning</code> header is sent, include a date that matches the {{HTTPHeader("Date")}} header.</dd>
</dl>

<h2 id="Warning_codes">Warning codes</h2>

<p>The <a href="http://www.iana.org/assignments/http-warn-codes/http-warn-codes.xhtml">HTTP Warn Codes registry at iana.org</a> defines the namespace for warn codes.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Code</th>
   <th scope="col">Text</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>110</td>
   <td>Response is Stale</td>
   <td>A response provided by a cache is stale (the expiration time set for it has passed).</td>
  </tr>
  <tr>
   <td>111</td>
   <td>Revalidation Failed</td>
   <td>An attempt to validate the response failed, due to an inability to reach the server.</td>
  </tr>
  <tr>
   <td>112</td>
   <td>Disconnected Operation</td>
   <td>The cache is disconnected from the rest of the network.</td>
  </tr>
  <tr>
   <td>113</td>
   <td>Heuristic Expiration</td>
   <td>Sent If a cache heuristically chose a freshness lifetime greater than 24 hours and the response's age is greater than 24 hours.</td>
  </tr>
  <tr>
   <td>199</td>
   <td>Miscellaneous Warning</td>
   <td>Arbitrary, non-specific warning</td>
  </tr>
  <tr>
   <td>214</td>
   <td>Transformation Applied</td>
   <td>Added by a proxy if it applies any transformation to the representation, such as changing the content-coding, media-type or the like.</td>
  </tr>
  <tr>
   <td>299</td>
   <td>Miscellaneous Persistent Warning</td>
   <td>Same as 199, but indicating a persistent warning</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<pre>Warning: 110 anderson/1.3.37 "Response is stale"

Date: Wed, 21 Oct 2015 07:28:00 GMT
Warning: 112 - "cache down" "Wed, 21 Oct 2015 07:28:00 GMT"
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Title</th>
  </tr>
  <tr>
   <td>{{RFC("7234", "Warning", "5.5")}}</td>
   <td>Hypertext Transfer Protocol (HTTP/1.1): Caching</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.Warning")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Date")}}</li>
 <li><a href="/en-US/docs/Web/HTTP/Status">HTTP response status codes</a></li>
</ul>
